# Simulacin del sistema
# masa-resorte-amortiguador
#
# Fraga 30/10/2012
# Fraga 13/11/2014
# El paso de muestreo se recibe por la linea de comandos
die "Args: ciclos_por_segundo\n" if $#ARGV != 0;

$cps = $ARGV[0];

$m = 0.1;
$b = 0.2;
$k = 0.8;
 
$dt = 1/$cps;

$dt2 = $dt * $dt;

$F = 0.1;

$k1 = ($F/$m)*$dt2;
$k2 = 2.0 - ($b/$m)*$dt - ($k/$m)*$dt2;
$k3 = ($b/$m)*$dt - 1.0;

$x_1 = 0;
$x = 0;

# $suma = 0;
print "0 0\n";
for( $i=1; $i<150; $i++ ) {
	$t = $i * $dt;
	$x1 = $k1 + $k2*$x + $k3*$x_1;

	$x_1 = $x; 
	$x = $x1;

	print "$t $x1\n";
	# $suma += $x;
}
# print "$suma\n";
