# Simulacin del sistema
# masa-resorte-amortiguador
#
# Fraga 30/10/2012
use strict;

my $m = 0.1;
my $b = 0.2;
my $k = 0.8;

# my $m = 0.1;
# my $b = 0.4/3;
# my $k = 8*0.16/3.6;

my $dt = 1.0/30;

my $lambda = $b/(2*$m);
my $w2 = $k/$m;
my $F = 0.1;
my $f = 0.1/$m;;

my $c2 = -$f/$w2;
my $k1 = sqrt( $w2 - $lambda*$lambda );

my $c1 = $lambda*$c2/$k1;

my $k3 = $f/$w2;

print "0 0\n";
# 150 muestras a 1/30 seg, es igual a 5 seg de simulacin
for( my $i=1; $i<150; $i++ ) {
	my $t = $i * $dt;

	my $v = $t*$k1;
	my $x = exp(-$lambda*$t)*( $c1*sin($v) + $c2*cos($v) ) + $k3;

	print "$t $x\n";
}
